package jp.ne.goo.mail.orangewind;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import org.aiwolf.client.base.player.AbstractPossessed;
import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import jp.ne.goo.mail.orangewind.Util.GameStatus;

/**
 * 狂人
 * @author M.K.
 *
 */
public class MKPossessed extends AbstractPossessed {
	protected final boolean isRethrowException = false; //例外を吐くか？

	GameStatus gameStatus = new GameStatus(this);

	//偽CO
	boolean isComingOut = false;

	//日別処理
	boolean isReported = false; //今日の占い結果を発言した？

	//ついた嘘
	List<Agent> isHuman = new ArrayList<Agent>();
	List<Agent> isWereWolf = new ArrayList<Agent>();

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting){
		super.initialize(gameInfo, gameSetting);

		gameStatus = new GameStatus(this);
		isComingOut = false;

		isHuman = new ArrayList<Agent>();
		isWereWolf = new ArrayList<Agent>();
	}

	@Override
	public void finish() {
		// 後始末

	}

	@Override
	public String talk() {
		try{
			// 基本的に占い騙り
			// 3-1か2-2かなど考えるの面倒なので占いのみで
			if(this.getDay() == 0){
				if(this.getGameInfo(this.getDay()).getTalkList().size() == 0){
					return TemplateTalkFactory.skip();
				}else if (!isComingOut){
					isComingOut = true;
					return TemplateTalkFactory.comingout(getMe(), Role.SEER); //占い騙り
				}else{
					return TemplateTalkFactory.over();
				}
			}else{
				if(!isReported){
					isReported = true;
					if(this.getDay() == 1){
						//適当な白出し
						Agent target = gameStatus.leastVoted();
						if (target == null){
							target = randomSelect(villagerList());
						}
						isHuman.add(target);
						return TemplateTalkFactory.divined(target, Species.HUMAN);
					}else{
						//過去に占われた人の中から、自分が占ってないやつを
						//パンダは別にいい。グレーはグレーのままにしておく
						List<Agent> targetList = new ArrayList<Agent>();
						targetList.addAll(gameStatus.divinedHumanAgents());
						targetList.addAll(gameStatus.divinedWerewolfAgents());
						targetList.removeAll(isHuman);
						targetList.removeAll(isWereWolf);
						if(targetList.size() == 0){
							//いなければやむなくパンダとグレーも見る
							targetList.addAll(gameStatus.notDivinedAgents());
							targetList.addAll(gameStatus.divinedPandaAgents());
							targetList.removeAll(isHuman);
							targetList.removeAll(isWereWolf);
							if(targetList.size() == 0){
								return TemplateTalkFactory.over(); //それでもいなければもう黙ってる
							}
						}

						//白出しか黒出しかはどっちでもいいので適当に
						int num = new Random().nextInt(2);
						if (num == 0){
							Agent target = randomSelect(targetList);
							isHuman.add(target);
							return TemplateTalkFactory.divined(target, Species.HUMAN);
						}else{
							Agent target = randomSelect(targetList);
							isWereWolf.add(target);
							return TemplateTalkFactory.divined(target, Species.WEREWOLF);
						}
					}
				}else{
					return TemplateTalkFactory.over();
				}
			}
		}catch(Exception ex){
	        if(isRethrowException){
	            throw ex;
	        }else{
	        	return TemplateTalkFactory.over();
	        }
		}
	}

	@Override
	public Agent vote() {
		try{
			//基本的に対抗占い
			//本当は人狼じゃないほうを名指ししないといけないけど、まあ混乱させられればそれでよし
			List<Agent> seers = gameStatus.getOtherSeer();
			if(seers.size() > 0){
				return randomSelect(seers);
			}else{
				//占いがいなかったら

				//黒出ししたのがいればそれ
				if(aliveList(isWereWolf).size() > 0){
					return randomSelect(aliveList(isWereWolf));
				}else{
					//いなければランダム

					//投票対象リスト
					List<Agent> voteCandidates = new ArrayList<Agent>();

					//生きてればリストに
					voteCandidates.addAll(getLatestDayGameInfo().getAliveAgentList());

					//自分を外す
					voteCandidates.remove(getMe());

					return randomSelect(voteCandidates);
				}
			}
		}catch(Exception ex){
	        if(isRethrowException){
	            throw ex;
	        }else{
	        	return getMe();
	        }
		}
	}

	@Override
	public void update(GameInfo gameInfo){
		try{
			super.update(gameInfo);

			gameStatus.addGameStatus(gameInfo);
		}catch(Exception ex){
	        if(isRethrowException){
	            throw ex;
	        }
		}
	}

	@Override
	public void dayStart() {
		try{
			// GameStatusの更新
			gameStatus.addGameStatus(getLatestDayGameInfo());

			//各種リセット
		}catch(Exception ex){
	        if(isRethrowException){
	            throw ex;
	        }
		}
	}

	//リスト渡すとランダムでAgent選択する
	private Agent randomSelect(List<Agent> agentList){
		int num = new Random().nextInt(agentList.size());
		return agentList.get(num);
	}

	//リストの中から生存者だけ返す
	private List<Agent> aliveList(List<Agent> agentList){
		List<Agent> aliveList = new ArrayList<Agent>();
		List<Agent> aliveAgents = this.getLatestDayGameInfo().getAliveAgentList();
		for(Agent agent: agentList){
			if (aliveAgents.contains(agent)){
				aliveList.add(agent);
			}
		}

		return aliveList;
	}

	/**
	 * 自分とCOした人間を除いた生存者リスト
	 * @param agentList
	 * @return
	 */
	private List<Agent> villagerList(){
		List<Agent> aliveVillagerList = new ArrayList<Agent>();
		aliveVillagerList.addAll(getLatestDayGameInfo().getAliveAgentList());
		aliveVillagerList.remove(getMe());

		//この時点で0になってしまうことはないはずだが
		//エラー防止のため一応
		if (aliveVillagerList.size() == 0){
			aliveVillagerList.add(getMe());
		}

		//COした人を除いたリストを取得する
		aliveVillagerList.removeAll(gameStatus.getOtherSeer());
		aliveVillagerList.removeAll(gameStatus.getOtherMedium());

		//いなかった場合は、COしててもいい
		if (aliveVillagerList.size() == 0){
			aliveVillagerList.addAll(gameStatus.getOtherSeer());
			aliveVillagerList.addAll(gameStatus.getOtherMedium());
		}

		return aliveVillagerList;
	}

}
