package jp.ne.goo.mail.orangewind;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import org.aiwolf.client.base.player.AbstractSeer;
import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import jp.ne.goo.mail.orangewind.Util.GameStatus;

//占い師
public class MKSeer extends AbstractSeer {
	protected final boolean isRethrowException = false; //例外を吐くか？

	GameStatus gameStatus = new GameStatus(this);

	boolean isComingOut = false;
	int readTalkNum = 0; //どこまで読み込んだ？

	boolean isReported = false; //今日の占い結果を発言した？

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting){
		super.initialize(gameInfo, gameSetting);

		gameStatus = new GameStatus(this);
		isComingOut = false;
	}

	@Override
	public void dayStart(){
		super.dayStart();

		//リセット
		readTalkNum = 0;
		isReported = false;
	}

	//占う
	@Override
	public Agent divine() {
		try{
			//占い対象リスト
			List<Agent> divineCandidates = new ArrayList<Agent>();

			boolean tempFlag = false;

			//生きてればリストに
			divineCandidates.addAll(getLatestDayGameInfo().getAliveAgentList());
			//占い済みと自分を外す
			divineCandidates.remove(getMe());
			for(Judge judge: getMyJudgeList()){
				if(divineCandidates.contains(judge.getTarget())){
					divineCandidates.remove(judge.getTarget());
				}
			}

			if(divineCandidates.size() > 0){
				tempFlag = true;
			}

			//占いCO者以外（霊媒COはOK）
			divineCandidates.remove(gameStatus.getOtherSeer());

			//リストできたら適当に
			if(divineCandidates.size() > 0){
				Agent leastVoted = gameStatus.leastVoted(divineCandidates);
				if (leastVoted != null){
					return  leastVoted;
				}else{
					return randomSelect(divineCandidates);
				}
				//return randomSelect(divineCandidates);
			}else{
				//全員占い済み（！？）なら、とりあえず自分を占う
				if(tempFlag){
					//生きてればリストに
					divineCandidates.addAll(getLatestDayGameInfo().getAliveAgentList());
					//占い済みと自分を外す
					divineCandidates.remove(getMe());
					for(Judge judge: getMyJudgeList()){
						if(divineCandidates.contains(judge.getTarget())){
							divineCandidates.remove(judge.getTarget());
						}
					}
					return randomSelect(divineCandidates);
				}else{
					return getMe();
				}
			}
		}catch(Exception ex){
	        if(isRethrowException){
	            throw ex;
	        }else{
	        	return getMe();
	        }
		}
	}

	@Override
	public void finish() {
		// 後始末

	}

	@Override
	public String talk() {
		try{
			if(isComingOut){
				//ここで条件を入れておかないと、いつまでもOverしなくて終わらない
				if(!isReported && this.getDay() != 0){
					isReported = true;
					Judge judge = getLatestDayGameInfo().getDivineResult();
					if (judge != null){
						String talk = TemplateTalkFactory.divined(judge.getTarget(), judge.getResult());
						return talk;
					}else{
						//初日とか
						return TemplateTalkFactory.over();
					}
				}else{
					return TemplateTalkFactory.over();
				}
			}else{
				if(this.getDay() > 0){
					String talk = TemplateTalkFactory.comingout(getMe(), getMyRole());
					isComingOut = true;
					return talk;
				}else{
					//初日は潜伏
					return TemplateTalkFactory.over();
				}
			}
		}catch(Exception ex){
	        if(isRethrowException){
	            throw ex;
	        }else{
	        	return TemplateTalkFactory.over();
	        }
		}
	}

	//投票
	@Override
	public Agent vote() {
		try{
			// 自分以外の占い師は狂人か人狼なので、ひたすら「あいつが人狼だ！」と投票でもよいかも

			//前日の占い結果が黒で、そいつが生きてれば、そこに投票
			Judge judge = getLatestDayGameInfo().getDivineResult();
			if (judge.getResult() == Species.WEREWOLF
					&& getLatestDayGameInfo().getAliveAgentList().contains(judge.getTarget())){
				return judge.getTarget();
			}

			//対抗占いがいればそちらに
			List<Agent> otherSeers = gameStatus.getOtherSeer();
			if (otherSeers.size() > 0){
				return randomSelect(otherSeers);
			}

			//対抗が黒出しした相手に投票するとたぶんダメなので、場の黒確状況はあまり信頼しない
			//なのでもうランダム

			//以下暫定実装
			//投票対象リスト
			List<Agent> voteCandidates = new ArrayList<Agent>();

			//生きてればリストに
			voteCandidates.addAll(getLatestDayGameInfo().getAliveAgentList());

			//自分を外す
			voteCandidates.remove(getMe());

			//霊媒がいれば外す
			voteCandidates.removeAll(gameStatus.getOtherMedium());
			if (voteCandidates.size() == 0){
				return randomSelect(gameStatus.getOtherMedium()); //こんなことはないと思うけど
			}

			return randomSelect(voteCandidates);
		}catch(Exception ex){
	        if(isRethrowException){
	            throw ex;
	        }else{
	        	return getMe();
	        }
		}
	}

	@Override
	public void update(GameInfo gameInfo){
		try{
			super.update(gameInfo);

			gameStatus.addGameStatus(gameInfo);
		}catch(Exception ex){
	        if(isRethrowException){
	            throw ex;
	        }
		}

/*		//今日のログ
		List<Talk> talkList = gameInfo.getTalkList();

		for (int i = readTalkNum; i < talkList.size(); i++){
			Talk talk = talkList.get(i);

			//発話をパース(Stringから発言型に)
			Utterance utterance = new Utterance(talk.getContent());

			//どういう発言だったかによって処理
			switch(utterance.getTopic()){
			case COMINGOUT:
				break;
			case DIVINED:
				break;
			default:
				break;
			}
			readTalkNum++;
		}*/
	}

	//リスト渡すとランダムで選択するやつ
	private Agent randomSelect(List<Agent> agentList){
		int num = new Random().nextInt(agentList.size());
		return agentList.get(num);
	}

}
