package jp.ne.goo.mail.orangewind;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import org.aiwolf.client.base.player.AbstractVillager;
import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import jp.ne.goo.mail.orangewind.Util.GameStatus;

public class MKVillager extends AbstractVillager {
	protected final boolean isRethrowException = false; //例外を吐くか？

	GameStatus gameStatus = new GameStatus(this);

	//今疑ってるAgent
	public Agent suspectedAgent = null;

	//初回発言です
	boolean isFirstTalk = true;
	//会話チェック
	int skipCount = 0;
	int coCount = 0;

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting){
		super.initialize(gameInfo, gameSetting);

		gameStatus = new GameStatus(this);
	}

	@Override
	public void dayStart() {
		try{
			// 一日の始まり

			//私はこいつを疑います
			suspectedAgent = randomSelect(villagerList());

			//各種リセット
			isFirstTalk = true;
			skipCount = 0;
			coCount = 0;
		}catch(Exception ex){
	        if(isRethrowException){
	            throw ex;
	        }
		}
	}

	@Override
	public void finish() {
		// ゲームの終わり。片付けとか。
		// 今回は特になし
	}

	@Override
	public void update(GameInfo gameInfo){
		try{
			super.update(gameInfo);

			gameStatus.addGameStatus(gameInfo);
		}catch(Exception ex){
	        if(isRethrowException){
	            throw ex;
	        }
		}
	}

	@Override
	public String talk() {
		try{
			if(isFirstTalk){
				isFirstTalk = false;
				return TemplateTalkFactory.vote(suspectedAgent); //疑ってる人に投票します
			}else{
				Agent votedAgent = gameStatus.mostVoted("villager");
				if (votedAgent == this.getMe()){
					//村人COはそこまで何度もやらない
					if(coCount < 2){
						coCount ++;
						return TemplateTalkFactory.comingout(getMe(), getMyRole()); //私は村人です！という主張
					}else if (coCount < 4){
						coCount ++;
						return TemplateTalkFactory.skip(); //状況が変わらないか様子見
					}else{
						return TemplateTalkFactory.over(); //諦める
					}
				}else if (suspectedAgent == votedAgent){
					if (skipCount < 1){
						//主流派に乗れている
						skipCount ++;
						return TemplateTalkFactory.skip();//様子見
						//***デバッグ***
	//					if(gameStatus.getOtherSeer().size() > 0){
	//						return TemplateTalkFactory.estimate(randomSelect(gameStatus.getOtherSeer()), Role.SEER);
	//					}else{
	//						return TemplateTalkFactory.agree(TalkType.TALK, 0, 0);
	//					}
					}else{
						return TemplateTalkFactory.over();
					}
				}else{
					//やっぱり変えよう
					if (votedAgent != null){
						suspectedAgent = votedAgent;
						return TemplateTalkFactory.vote(suspectedAgent); //変えました
					}else{
						skipCount ++;
						return TemplateTalkFactory.skip();//様子見
					}
				}
			}
		}catch(Exception ex){
	        if(isRethrowException){
	            throw ex;
	        }else{
	        	return TemplateTalkFactory.over();
	        }
		}

/*		//以下をランダムで
		//村人は役職騙りはしない。適当に疑って吊られる仕事です
		List<String> talkList = new ArrayList<String>();
		talkList.add(TemplateTalkFactory.comingout(getMe(), getMyRole())); //私は村人です
		talkList.add(TemplateTalkFactory.estimate(suspectedAgent, Role.WEREWOLF)); //疑ってる人が人狼だと思います
		talkList.add(TemplateTalkFactory.skip());

		talkList.add(TemplateTalkFactory.over());
*/
	}

	@Override
	public Agent vote() {
		//最終的に疑った相手に投票します
		return suspectedAgent;
	}

	//リスト渡すとランダムでAgent選択する
	private Agent randomSelect(List<Agent> agentList){
		int num = new Random().nextInt(agentList.size());
		return agentList.get(num);
	}

/*	//リスト渡すとランダムでString選択する
	private String randomTalkSelect(List<String> talkList){
		int num = new Random().nextInt(talkList.size());
		return talkList.get(num);
	}*/

	/**
	 * 自分とCOした人間を除いた生存者リスト
	 * @param agentList
	 * @return
	 */
	private List<Agent> villagerList(){
		List<Agent> aliveVillagerList = new ArrayList<Agent>();
		aliveVillagerList.addAll(getLatestDayGameInfo().getAliveAgentList());
		aliveVillagerList.remove(getMe());

		//この時点で0になってしまうことはないはずだが
		//エラー防止のため一応
		if (aliveVillagerList.size() == 0){
			aliveVillagerList.add(getMe());
		}

		//ここでCOした人を除いたリストをどうにか取得する
		aliveVillagerList.removeAll(gameStatus.getOtherSeer());
		aliveVillagerList.removeAll(gameStatus.getOtherMedium());

		//いなかった場合は、COしててもいいや
		if (aliveVillagerList.size() == 0){
			aliveVillagerList.addAll(gameStatus.getOtherSeer());
			aliveVillagerList.addAll(gameStatus.getOtherMedium());
		}

		return aliveVillagerList;
	}
}
