package jp.ne.goo.mail.orangewind;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import org.aiwolf.client.base.player.AbstractWerewolf;
import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.client.lib.TemplateWhisperFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import jp.ne.goo.mail.orangewind.Util.GameStatus;

//人狼
public class MKWerewolf extends AbstractWerewolf {
	protected final boolean isRethrowException = false; //例外を吐くか？

	GameStatus gameStatus = new GameStatus(this);

	Agent wolfSeer = null;

	Agent attackTarget = null;

	int talkCount = 0;
	boolean saidAttackTarget = false;

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting){
		super.initialize(gameInfo, gameSetting);

		gameStatus = new GameStatus(this);
		wolfSeer = null;
	}

	@Override
	public Agent attack() {
		try{
			if (attackTarget == null){
				attackTarget = this.choiceAttackCandidates();
			}
			return attackTarget;
		}catch(Exception ex){
	        if(isRethrowException){
	            throw ex;
	        }else{
	        	List<Agent> tempList = getLatestDayGameInfo().getAliveAgentList();
	        	tempList.removeAll(this.getWolfList());
	        	return randomSelect(tempList); //自分を返す可能性はあるが仕方ない
	        }
		}
	}

	@Override
	public void dayStart() {
		try{
			// GameStatusの更新
			gameStatus.addGameStatus(getLatestDayGameInfo());

			talkCount = 0;
			attackTarget = null;
			saidAttackTarget = false;
		}catch(Exception ex){
	        if(isRethrowException){
	            throw ex;
	        }
		}
	}

	@Override
	public void finish() {
		// 後始末

	}

	@Override
	public void update(GameInfo gameInfo){
		try{
			super.update(gameInfo);

			gameStatus.addGameStatus(gameInfo);

			if (wolfSeer == null){
				List<Agent> seerList = gameStatus.getOtherSeer();
				for(Agent wolf:this.getWolfList()){
					if (seerList.contains(wolf)){
						wolfSeer = wolf;
					}
				}
			}else{
				//味方占い師が死んでた場合
				if(!getLatestDayGameInfo().getAliveAgentList().contains(wolfSeer)){
					wolfSeer = null;
				}
			}
		}catch(Exception ex){
	        if(isRethrowException){
	            throw ex;
	        }
		}
	}

	@Override
	public String talk() {
		try{
			//ひとまず騙らない場合を実装

			// 味方占い師を信じる
			// ラインつながりきらないように他の占い師も適度に信じる
			// ……結局、味方占い師が誰かはあまり問題じゃない……？
			if(talkCount < 3){
				talkCount++;
				List<Agent> panda = gameStatus.divinedPandaAgents();
				for (Agent wolf:getWolfList()){
					if (panda.contains(wolf)){
						//パンダの中に人狼がいたらとりあえずかばう
						return TemplateTalkFactory.estimate(wolf, Role.VILLAGER);
					}
				}
				//いなければ適当に
				int num = new Random().nextInt(2);
				List<Agent> divineds = new ArrayList<Agent>();
				if (num == 0){
					//白出し
					divineds.addAll(gameStatus.divinedHumanAgents());
					divineds.addAll(gameStatus.divinedPandaAgents());
					divineds.removeAll(gameStatus.getOtherSeer());
					divineds.removeAll(gameStatus.getOtherMedium());
					if(divineds.size() > 0){
						Agent target = randomSelect(divineds);
						return TemplateTalkFactory.estimate(target, Role.VILLAGER);
					}else{
						return TemplateTalkFactory.skip();
					}
				}else{
					//黒出し（ライン切る意味もあって）
					divineds.addAll(gameStatus.divinedWerewolfAgents());
					divineds.addAll(gameStatus.divinedPandaAgents());
					divineds.removeAll(gameStatus.getOtherSeer());
					divineds.removeAll(gameStatus.getOtherMedium());
					if(divineds.size() > 0){
						Agent target = randomSelect(divineds);
						return TemplateTalkFactory.estimate(target, Role.WEREWOLF);
					}else{
						return TemplateTalkFactory.skip();
					}
				}
			}else{
				return TemplateTalkFactory.over();
			}
		}catch(Exception ex){
	        if(isRethrowException){
	            throw ex;
	        }else{
	        	return TemplateTalkFactory.over();
	        }
		}
	}

	@Override
	public Agent vote() {
		try{
			//一応流れには乗っかる
			if (gameStatus.mostVoted() != null && !getWolfList().contains(gameStatus.mostVoted())){
				return gameStatus.mostVoted();
			}

			//投票対象リスト
			List<Agent> voteCandidates = new ArrayList<Agent>();

			//生きてればリストに
			voteCandidates.addAll(getLatestDayGameInfo().getAliveAgentList());

			//自分を外す
			voteCandidates.remove(getMe());

			//人狼も外す
			voteCandidates.removeAll(getWolfList());

			if(voteCandidates.size() > 0){
				return randomSelect(voteCandidates);
			}else{
				//ここに来ることはないと思うのだが……。
				return randomSelect(getLatestDayGameInfo().getAliveAgentList());
			}
		}catch(Exception ex){
	        if(isRethrowException){
	            throw ex;
	        }else{
	        	return getMe();
	        }
		}
	}

	private Agent choiceAttackCandidates(){
		//狩人COがいればそれ
		//狂人COとまとめちゃってるけど、まあいい
		if(gameStatus.getOtherCOList().size() > 0){
			return randomSelect(gameStatus.getOtherCOList());
		}

		// 白確から噛む
		// 真占っぽいのはいきなり噛まない
		List<Agent> targetList = gameStatus.divinedHumanAgents();
		targetList.removeAll(getWolfList());
		if (targetList.size() > 0){
			return randomSelect(targetList);
		}
		//上記処理でターゲットがいなければ、下記処理で

		//this.getWolfList()で人狼とれる
		//噛み対象リスト
		List<Agent> attackCandidates = new ArrayList<Agent>();

		//生きてればリストに
		attackCandidates.addAll(getLatestDayGameInfo().getAliveAgentList());

		//人狼を外す。これで自分も外れるはず
		for (Agent wolf: this.getWolfList()){
			attackCandidates.remove(wolf);
		}

		//吊られそうな人間は外す
		Agent votedAgent = gameStatus.mostVoted();
		if(votedAgent != null){
			attackCandidates.remove(votedAgent);
		}

		if (attackCandidates.size() == 0){
			//これはおかしい
			//少なくとも自分以外に生きている人間が複数いるはず……。
			//一応ターゲットリストを作り直して対応
			attackCandidates = new ArrayList<Agent>();
			attackCandidates.addAll(getLatestDayGameInfo().getAliveAgentList());
			attackCandidates.remove(getMe());

			return randomSelect(attackCandidates);
		}else{
			return randomSelect(attackCandidates);
		}
	}

	@Override
	public String whisper() {
		try{
			if(!saidAttackTarget){
				attackTarget = choiceAttackCandidates();
				saidAttackTarget = true;
				return TemplateWhisperFactory.attack(attackTarget);
			}else{
				return TemplateWhisperFactory.over();
			}
		}catch(Exception ex){
	        if(isRethrowException){
	            throw ex;
	        }else{
	        	return TemplateWhisperFactory.over();
	        }
		}
	}

	//リスト渡すとランダムでAgent選択する
	private Agent randomSelect(List<Agent> agentList){
		int num = new Random().nextInt(agentList.size());
		return agentList.get(num);
	}

}
